/*
 * @module     local_deepler/deepler
 * @package    local_deepler
 * @file       amd/src/deepler.js
 * @copyright  2022 Kaleb Heitzman <kaleb@jamfire.io>
 * @copyright  2024 Bruno Baudry <bruno.baudry@bfh.ch>
 * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */
define("local_deepler/deepler",["core/ajax","./selectors","core/modal","core/str","./tokeniser"],((Ajax,Selectors,Modal,Str,Tokeniser)=>{const getString=Str.get_string,{escapeReplacementString:escapeReplacementString,postprocess:postprocess,preprocess:preprocess}=Tokeniser;let tempTranslations={},mainEditorType="",config={},autotranslateButton={},checkboxes=[],sourceLang="",targetLang="",saveAllBtn={},usage={},format=new Intl.NumberFormat,saveAllModal={};const escapePatterns={};let log=function(){for(var _len=arguments.length,a=new Array(_len),_key=0;_key<_len;_key++)a[_key]=arguments[_key];return a},warn=function(){for(var _len2=arguments.length,a=new Array(_len2),_key2=0;_key2<_len2;_key2++)a[_key2]=arguments[_key2];return a},info=function(){for(var _len3=arguments.length,a=new Array(_len3),_key3=0;_key3<_len3;_key3++)a[_key3]=arguments[_key3];return a},error=function(){for(var _len4=arguments.length,a=new Array(_len4),_key4=0;_key4<_len4;_key4++)a[_key4]=arguments[_key4];return a};const debug_MINIMAL=5,debug_NORMAL=15,debug_ALL=30719,debug_DEVELOPER=32767,showErrorMessageForEditor=(key,message)=>{let parent=document.querySelector(Selectors.editors.multiples.editorsWithKey.replace("<KEY>",key));const errorMsg=document.createElement("div");errorMsg.id="local_deepler__errormsg",errorMsg.classList=["alert alert-danger"],errorMsg.innerHTML=message,parent.appendChild(errorMsg)},hideErrorMessage=key=>{let parent=document.querySelector(Selectors.editors.multiples.editorsWithKey.replace("<KEY>",key)),alertChild=parent.querySelector(".alert-danger");alertChild&&parent.removeChild(alertChild)},launchModal=async()=>{saveAllModal=await Modal.create({title:getString("saveallmodaltitle","local_deepler"),body:getString("saveallmodalbody","local_deepler")}),await saveAllModal.show()},errorMessageItem=(key,editor,message)=>{editor.classList.add("local_deepler__error"),setIconStatus(key,Selectors.statuses.failed),showErrorMessageForEditor(key,message)},handleAjaxUpdateDBResponse=data=>{data.forEach((item=>{if(""===item.keyid)getString("errordbtitle","local_deepler").then((s=>(Modal.create({title:s,body:item.error,type:"ALERT",show:!0,removeOnClose:!0}),s))).catch((error=>{error("errordbtitle, could not get Moodle string!!!")}));else{const key=keyidToKey(item.keyid),htmlElement=document.querySelector(replaceKey(Selectors.editors.multiples.editorsWithKey,key)),multilangTextarea=document.querySelector(replaceKey(Selectors.editors.multiples.textAreas,key));if(void 0!==item.error){const indexOfSET=item.error.indexOf("SET");indexOfSET>-1?getString("errortoolong","local_deepler").then((s=>{errorMessageItem(key,tempTranslations[key].editor,item.error.slice(0,indexOfSET)+"<br/>"+s)})).catch((error=>{error("errortoolong, could not get Moodle string!!!")})):errorMessageItem(key,tempTranslations[key].editor,item.error)}else((key,element)=>{element.classList.add("local_deepler__success"),setIconStatus(key,Selectors.statuses.success),setTimeout((()=>{let multilangPill=document.querySelector(replaceKey(Selectors.statuses.multilang,key));document.querySelector(replaceKey(Selectors.statuses.prevTransStatus,key)).classList="badge badge-pill badge-success",multilangPill.classList.contains("disabled")&&multilangPill.classList.remove("disabled"),setIconStatus(key,Selectors.statuses.saved)}))})(key,htmlElement),multilangTextarea.innerHTML=item.text,document.querySelector(Selectors.editors.multiples.checkBoxesWithKey.replace("<KEY>",key)).checked=!1}}))},saveTranslations=keys=>{const data=[];keys.forEach((key=>{document.querySelector(replaceKey(Selectors.actions.validatorBtn,key)).getAttribute("data-status")===Selectors.statuses.tosave&&(hideErrorMessage(key),data.push(prepareDbUpdatdeItem(key)))})),Ajax.call([{methodname:"local_deepler_update_translation",args:{data:data},done:data=>{info(data),null!==saveAllModal&&saveAllModal.isVisible&&saveAllModal.hide(),data.length>0?handleAjaxUpdateDBResponse(data):keys.forEach((key=>{errorMessageItem(key,tempTranslations[key].editor,"Something went wrong with the data")}))},fail:(jqXHR,status,error)=>{warn(jqXHR,status,error),null!==saveAllModal&&saveAllModal.isVisible&&saveAllModal.hide(),getString("errordbtitle","local_deepler").then((s=>(Modal.create({title:s,body:error,type:"ALERT",show:!0,removeOnClose:!0}),s))).catch((error=>{error("errordbtitle, could not get Moodle string!!!")})),keys.forEach((key=>{errorMessageItem(key,tempTranslations[key].editor,status+":"+error.toString())}))}}])},saveTranslation=key=>{hideErrorMessage(key),Ajax.call([{methodname:"local_deepler_update_translation",args:{data:[prepareDbUpdatdeItem(key)]},done:data=>{info(data),data.length>0?handleAjaxUpdateDBResponse(data):errorMessageItem(key,tempTranslations[key].editor,"Something went wrong with the data")},fail:err=>{null!==saveAllModal&&saveAllModal.isVisible&&saveAllModal.hide(),warn(err),errorMessageItem(key,tempTranslations[key].editor,err.toString())}}])},prepareDbUpdatdeItem=key=>{const textTranslated=(editor=>{let text=editor.innerHTML;return"textarea"===mainEditorType&&(text=decodeHTML(text)),text})(tempTranslations[key].editor),sourceText=(key=>{const sourceTokenised=tempTranslations[key].source;return postprocess(sourceTokenised,tempTranslations[key].tokens)})(key),fieldText=tempTranslations[key].fieldText,element=document.querySelector(replaceKey(Selectors.editors.multiples.editorsWithKey,key)),{id:id,tid:tid,field:field,table:table}=(element=>({id:parseInt(element.getAttribute("data-id")),tid:element.getAttribute("data-tid"),table:element.getAttribute("data-table"),field:element.getAttribute("data-field")}))(element),textTosave=getupdatedtext(fieldText,textTranslated,sourceText,tempTranslations[key].sourceLang);return{courseid:config.courseid,id:id,tid:tid,field:field,table:table,text:textTosave}},getupdatedtext=(fieldtext,translation,source,sourceItemLang)=>{const isFirstTranslation=-1===fieldtext.indexOf("{mlang"),isSourceOther=sourceItemLang===sourceLang,tagPatterns={other:"({mlang other)(.*?){mlang}",target:"({mlang ".concat(targetLang,"}(.*?){mlang})"),source:"({mlang ".concat(sourceItemLang,"}(.*?){mlang})")},langsItems={fullContent:fieldtext,other:"{mlang other}".concat(source,"{mlang}"),target:"{mlang ".concat(targetLang,"}").concat(translation,"{mlang}"),source:"{mlang ".concat(sourceItemLang,"}").concat(source,"{mlang}")};return isFirstTranslation?isSourceOther?langsItems.other+langsItems.target:langsItems.other+langsItems.source+langsItems.target:additionalUpdate(isSourceOther,tagPatterns,langsItems)},additionalUpdate=(isSourceOther,tagPatterns,langsItems)=>{let manipulatedText=langsItems.fullContent;const targetReg=new RegExp(tagPatterns.target,"sg");if(manipulatedText.match(targetReg))manipulatedText=manipulatedText.replace(targetReg,escapeReplacementString(langsItems.target));else{const lastMlangClosingTagEnd=manipulatedText.lastIndexOf("{mlang}")+7;manipulatedText=[manipulatedText.slice(0,lastMlangClosingTagEnd),langsItems.target,manipulatedText.slice(lastMlangClosingTagEnd)].join("")}const otherReg=new RegExp(tagPatterns.other,"sg"),hasTagOther=manipulatedText.match(otherReg),sourceReg=new RegExp(tagPatterns.other,"sg"),hasTagSource=manipulatedText.match(sourceReg);if(isSourceOther)manipulatedText=manipulatedText.replace(otherReg,escapeReplacementString(langsItems.other)),hasTagSource&&manipulatedText.replace(sourceReg,"");else{if(!hasTagOther){const firstMlangClosingTagEnd=manipulatedText.indexOf("{mlang");manipulatedText=[manipulatedText.slice(0,firstMlangClosingTagEnd),langsItems.other,manipulatedText.slice(firstMlangClosingTagEnd)].join("")}hasTagSource||manipulatedText.replace(sourceReg,escapeReplacementString(langsItems.source))}return manipulatedText},onItemChecked=e=>{log("SELECTION",e.target.getAttribute("data-key"),e.target.getAttribute("data-action"));const key=e.target.getAttribute("data-key");"local_deepler/checkbox"===e.target.getAttribute("data-action")?(toggleStatus(key,e.target.checked),countWordAndChar()):initTempForKey(key,!1)},initTempForKey=(key,blank)=>{const sourceSelector=Selectors.sourcetexts.keys.replace("<KEY>",key),sourceTextEncoded=document.querySelector(sourceSelector).getAttribute("data-sourcetext-raw"),multilangRawTextEncoded=document.querySelector(sourceSelector).getAttribute("data-filedtext-raw"),sourceText=fromBase64(sourceTextEncoded),fieldText=fromBase64(multilangRawTextEncoded),tokenised=preprocess(sourceText,escapePatterns,escapePatterns),editorSettings=findEditor(key),sourceLang=document.querySelector(Selectors.sourcetexts.sourcelangs.replace("<KEY>",key)).value;tempTranslations[key]={editorType:null,editor:null,source:"",sourceLang:"",fieldText:"",status:"",translation:"",tokens:[]},blank||(null===editorSettings||null===editorSettings.editor?(setIconStatus(key,Selectors.statuses.failed),showErrorMessageForEditor(key,"Original editor not found...")):tempTranslations[key]={editorType:editorSettings.editorType,editor:editorSettings.editor,source:tokenised.tokenizedText,sourceLang:sourceLang,fieldText:fieldText,status:Selectors.statuses.wait,translation:"",tokens:tokenised.expressions})},toggleStatus=(key,checked)=>{var _tempTranslations$key,_tempTranslations$key2;switch(document.querySelector(replaceKey(Selectors.actions.validatorBtn,key)).dataset.status){case Selectors.statuses.wait:checked?(setIconStatus(key,Selectors.statuses.totranslate),initTempForKey(key,!1)):initTempForKey(key,!0);break;case Selectors.statuses.totranslate:checked&&(null===(_tempTranslations$key=tempTranslations[key])||void 0===_tempTranslations$key||null===(_tempTranslations$key2=_tempTranslations$key.translation)||void 0===_tempTranslations$key2?void 0:_tempTranslations$key2.length)>0?setIconStatus(key,Selectors.statuses.tosave,!0):setIconStatus(key,Selectors.statuses.wait);break;case Selectors.statuses.tosave:checked||setIconStatus(key,Selectors.statuses.totranslate);case Selectors.statuses.failed:case Selectors.statuses.success:case Selectors.statuses.saved:}},setIconStatus=function(key){let status=arguments.length>1&&void 0!==arguments[1]?arguments[1]:Selectors.statuses.wait,isBtn=arguments.length>2&&void 0!==arguments[2]&&arguments[2],icon=document.querySelector(replaceKey(Selectors.actions.validatorBtn,key));isBtn?(icon.classList.contains("btn")||(icon.classList.add("btn"),icon.classList.add("btn-outline-secondary")),icon.classList.contains("disable")&&icon.classList.remove("disable")):(icon.classList.contains("disable")||icon.classList.add("disable"),icon.classList.contains("btn")&&(icon.classList.remove("btn"),icon.classList.remove("btn-outline-secondary"))),icon.setAttribute("role",isBtn?"button":"status"),icon.setAttribute("data-status",status),icon.setAttribute("title",config.statusstrings[status.replace("local_deepler/","")])},showRows=(selector,selected)=>{const items=document.querySelectorAll(selector),allSelected=document.querySelector(Selectors.actions.selectAllBtn).checked;items.forEach((item=>{let k=item.getAttribute("data-row-id");toggleRowVisibility(item,selected);try{item.querySelector(replaceKey(Selectors.editors.multiples.checkBoxesWithKey,k)).checked=allSelected&&selected,toggleStatus(k,!1)}catch(e){log("".concat(k," translation is disalbled"))}})),toggleAutotranslateButton(),countWordAndChar()},toggleRowVisibility=(row,checked)=>{checked?row.classList.remove("d-none"):row.classList.add("d-none")},switchTarget=e=>{let url=new URL(window.location.href);url.searchParams.set("target_lang",e.target.value),window.location=url.toString()},switchSource=e=>{let url=new URL(window.location.href);url.searchParams.set("lang",e.target.value),window.location=url.toString()},doAutotranslate=()=>{log("Do auto translate"),saveAllBtn.disabled=!1,document.querySelectorAll(Selectors.statuses.checkedCheckBoxes).forEach((ckBox=>{let key=ckBox.getAttribute("data-key");initTempForKey(key),null!==tempTranslations[key].editor&&getTranslation(key)}))},prepareFormData=function(key){let formData=!(arguments.length>1&&void 0!==arguments[1])||arguments[1]?new URLSearchParams:new FormData;return Object.entries((()=>{var _document$querySelect;info("prepareAdvancedSettings");let settings={};return escapePatterns.LATEX=document.querySelector(Selectors.actions.escapeLatex).checked,escapePatterns.PRETAG=document.querySelector(Selectors.actions.escapePre).checked,settings.tag_handling=document.querySelector(Selectors.deepl.tagHandling).checked?"html":"xml",settings.context=null!==(_document$querySelect=document.querySelector(Selectors.deepl.context).value)&&void 0!==_document$querySelect?_document$querySelect:null,settings.split_sentences=document.querySelector(Selectors.deepl.splitSentences).value,settings.preserve_formatting=document.querySelector(Selectors.deepl.preserveFormatting).checked,settings.formality=document.querySelector('[name="local_deepler/formality"]:checked').value,settings.glossary_id=document.querySelector(Selectors.deepl.glossaryId).value,settings.outline_detection=document.querySelector(Selectors.deepl.outlineDetection).checked,settings.non_splitting_tags=toJsonArray(document.querySelector(Selectors.deepl.nonSplittingTags).value),settings.splitting_tags=toJsonArray(document.querySelector(Selectors.deepl.splittingTags).value),settings.ignore_tags=toJsonArray(document.querySelector(Selectors.deepl.ignoreTags).value),settings.target_lang=targetLang.toUpperCase(),settings.auth_key=config.apikey,settings})()).forEach((_ref=>{let[k,v]=_ref;formData.append(k,v)})),initTempForKey(key,!1),Object.entries((key=>({text:tempTranslations[key].source,source_lang:tempTranslations[key].sourceLang}))(key)).forEach((_ref2=>{let[k,v]=_ref2;formData.append(k,v)})),formData},getTranslation=key=>{var _XMLHttpRequest$DONE;log("getTranslation");const readystateDone=null!==(_XMLHttpRequest$DONE=XMLHttpRequest.DONE)&&void 0!==_XMLHttpRequest$DONE?_XMLHttpRequest$DONE:4;tempTranslations[key].staus=Selectors.statuses.wait;let formData=prepareFormData(key);if(null===tempTranslations[key].editor)error("".concat(key," no editor found :(("));else{info("Send deepl:",formData);let xhr=new XMLHttpRequest;xhr.responseType="json",xhr.onreadystatechange=()=>{if(xhr.readyState===readystateDone){const status=xhr.status;if(0===status||status>=200&&status<400){log(tempTranslations);let data="text"===xhr.responseType||""===xhr.responseType?JSON.parse(xhr.responseText):xhr.response;info("From deepl:",data);let tr=postprocess(data.translations[0].text,tempTranslations[key].tokens,escapePatterns);log(tr),tempTranslations[key].editor.innerHTML=tr,tempTranslations[key].translation=tr,setIconStatus(key,Selectors.statuses.tosave,!0),injectImageCss(tempTranslations[key].editorType,tempTranslations[key].editor)}else setIconStatus(key,Selectors.statuses.failed,!1)}else"number"!=typeof xhr.readyState&&log('ERROR: Some JS library in your Moodle install are overriding the core functionalities in a wrong way.xhr.readyState MUST be of type "number"')},xhr.open("POST",config.deeplurl),xhr.send(formData)}},injectImageCss=(editorType,editor)=>{const css=document.createElement("style");if(css.textContent="img{background-color:yellow !important;font-style: italic;}","iframe"===editorType){let editorschildrens=Array.from(editor.parentElement.children),found=!1;for(let j in editorschildrens){if(editorschildrens[j].innerText===css.innerText){found=!0;break}}found||editor.parentElement.appendChild(css)}},findEditor=key=>{let e=document.querySelector(Selectors.editors.types.basic.replace("<KEY>",key));if(null===e){let r=null;if(-1===["atto","tiny","marklar","textarea"].indexOf(mainEditorType))warn("Unsupported editor "+mainEditorType);else try{r=findEditorByType(key,mainEditorType)}catch(error){log("Editor not found: ".concat(mainEditorType," for key ").concat(key))}return r}return{editor:e,editorType:"basic"}},findEditorByType=(key,editorType)=>{let et="basic",ed=null;switch(editorType){case"atto":et="iframe",ed=document.querySelector(Selectors.editors.types.atto.replaceAll("<KEY>",key));break;case"tiny":et="iframe",ed=document.querySelector(Selectors.editors.types.tiny.replaceAll("<KEY>",key)).contentWindow.tinymce;break;case"marklar":case"textarea":ed=document.querySelector(Selectors.editors.types.other.replaceAll("<KEY>",key))}return{editor:ed,editorType:et}},toggleAllCheckboxes=e=>{e.target.checked?checkboxes.forEach((i=>{i.checked=!getParentRow(i).classList.contains("d-none"),toggleStatus(i.getAttribute("data-key"),i.checked)})):checkboxes.forEach((i=>{i.checked=!1,toggleStatus(i.getAttribute("data-key"),!1)})),toggleAutotranslateButton(),countWordAndChar()},getParentRow=node=>node.closest(replaceKey(Selectors.sourcetexts.parentrow,node.getAttribute("data-key"))),toggleAutotranslateButton=()=>{autotranslateButton.disabled=!0;for(let i in checkboxes){if(checkboxes[i].checked){autotranslateButton.disabled=!1;break}}},onToggleMultilang=e=>{let keyid=e.getAttribute("aria-controls"),key=keyidToKey(keyid),source=document.querySelector(replaceKey(Selectors.sourcetexts.keys,key)),multilang=document.querySelector(replaceKey(Selectors.sourcetexts.multilangs,keyid));source.classList.toggle("show"),multilang.classList.toggle("show")},toJsonArray=function(s){let sep=arguments.length>1&&void 0!==arguments[1]?arguments[1]:",";return JSON.stringify(s.split(sep))},replaceKey=(s,k)=>s.replace("<KEY>",k),keyidToKey=k=>{let m=k.match(/^(.+)-(.+)-(.+)$/i);return"".concat(m[1],"[").concat(m[2],"][").concat(m[3],"]")},countWordAndChar=()=>{let wrdsc=0,cws=0,cwos=0;document.querySelectorAll(Selectors.statuses.checkedCheckBoxes).forEach((ckBox=>{let key=ckBox.getAttribute("data-key"),results=getCount(key);wrdsc+=results.wordCount,cwos+=results.charNumWithOutSpace,cws+=results.charNumWithSpace}));const wordCount=document.querySelector(Selectors.statuses.wordcount),charWithSpace=document.querySelector(Selectors.statuses.charNumWithSpace),charWOSpace=document.querySelector(Selectors.statuses.charNumWithOutSpace),deeplUseSpan=document.querySelector(Selectors.statuses.deeplUsage),deeplMaxSpan=document.querySelector(Selectors.statuses.deeplMax),parent=document.querySelector(Selectors.statuses.deeplStatusContainer);let current=cwos+usage.character.count;wordCount.innerText=wrdsc,charWithSpace.innerText=cws,charWOSpace.innerText=cwos,deeplUseSpan.innerText=format.format(current),deeplMaxSpan.innerText=null===usage.character.limit?"∞":format.format(usage.character.limit),current>=usage.character.limit?(parent.classList.remove("alert-success"),parent.classList.add("alert-danger")):(parent.classList.add("alert-success"),parent.classList.remove("alert-danger"))},getCount=key=>{const raw=document.querySelector(replaceKey(Selectors.sourcetexts.keys,key)).getAttribute("data-sourcetext-raw"),trimmedVal=stripHTMLTags(fromBase64(raw)).trim();return{wordCount:(trimmedVal.match(/\S+/g)||[]).length,charNumWithSpace:trimmedVal.length,charNumWithOutSpace:trimmedVal.replace(/\s+/g,"").length}},fromBase64=encoded=>{const binString=atob(encoded),bytes=Uint8Array.from(binString,(m=>m.codePointAt(0)));return(new TextDecoder).decode(bytes)},decodeHTML=encodedStr=>(new DOMParser).parseFromString(encodedStr,"text/html").documentElement.textContent,stripHTMLTags=str=>(new DOMParser).parseFromString(str,"text/html").body.textContent||"";return{init:cfg=>{log("init"),config=cfg,usage=config.usage,config.debug===debug_MINIMAL?error=window.console.error.bind(window.console):config.debug===debug_NORMAL?(error=window.console.error.bind(window.console),warn=window.console.warn.bind(window.console)):config.debug===debug_ALL?(error=window.console.error.bind(window.console),warn=window.console.warn.bind(window.console),info=window.console.info.bind(window.console)):config.debug===debug_DEVELOPER&&(error=window.console.error.bind(window.console),warn=window.console.warn.bind(window.console),info=window.console.info.bind(window.console),log=window.console.log.bind(window.console)),info("DEEPLER loaded"),log(config),warn("Deepl's usage",usage),error("testing developper level (Your Moodle is set with dev debug level to the max)"),mainEditorType=config.userPrefs,(()=>{try{saveAllBtn=document.querySelector(Selectors.actions.saveAll),sourceLang=document.querySelector(Selectors.actions.sourceSwitcher).value,targetLang=document.querySelector(Selectors.actions.targetSwitcher).value,autotranslateButton=document.querySelector(Selectors.actions.autoTranslateBtn),checkboxes=document.querySelectorAll(Selectors.actions.checkBoxes),checkboxes.forEach((node=>{tempTranslations[node.dataset.key]={}}))}catch(e){config.debug&&error(e.message)}})(),document.addEventListener("change",(e=>{e.target.closest(Selectors.actions.targetSwitcher)&&switchTarget(e),e.target.closest(Selectors.actions.sourceSwitcher)&&switchSource(e),e.target.closest(Selectors.actions.showUpdated)&&showRows(Selectors.statuses.updated,e.target.checked),e.target.closest(Selectors.actions.showNeedUpdate)&&showRows(Selectors.statuses.needsupdate,e.target.checked),(e.target.closest(Selectors.actions.checkBoxes)||e.target.closest(Selectors.actions.sourceselect))&&onItemChecked(e)})),document.addEventListener("click",(e=>{if(e.target.closest(Selectors.actions.toggleMultilang)&&onToggleMultilang(e.target.closest(Selectors.actions.toggleMultilang)),e.target.closest(Selectors.actions.autoTranslateBtn)&&(config.currentlang===config.lang||void 0===config.lang?Modal.create({title:"Cannot call deepl",body:"<p>Both languges are the same {$config.lang}</p>",show:!0,removeOnClose:!0}):doAutotranslate()),e.target.closest(Selectors.actions.selectAllBtn)&&toggleAllCheckboxes(e),e.target.closest(Selectors.actions.saveAll)){const selected=document.querySelectorAll(Selectors.statuses.checkedCheckBoxes),allKeys=Array.from(selected).map((e=>e.dataset.key));log(allKeys),allKeys.length>0&&(launchModal(),saveAllBtn.disabled=!0,saveTranslations(allKeys))}})),toggleAutotranslateButton(),saveAllBtn.disabled=!0;document.querySelector(Selectors.actions.selectAllBtn).disabled=sourceLang===targetLang;document.querySelectorAll(Selectors.actions.validatorsBtns).forEach((item=>{item.addEventListener("click",(e=>{const key=e.target.closest(Selectors.actions.validatorsBtns).dataset.keyValidator;let currentStatus=document.querySelector(replaceKey(Selectors.actions.validatorBtn,key)).getAttribute("data-status");null===tempTranslations[key]||void 0===tempTranslations[key]?error('Translation key "'.concat(key,'" is undefined ')):currentStatus===Selectors.statuses.tosave&&saveTranslation(key)}))})),checkboxes.forEach((e=>{e.disabled=sourceLang===targetLang,e.addEventListener("click",(()=>{toggleAutotranslateButton()}))})),showRows(Selectors.statuses.updated,document.querySelector(Selectors.actions.showUpdated).checked),showRows(Selectors.statuses.needsupdate,document.querySelector(Selectors.actions.showNeedUpdate).checked)}}}));

//# sourceMappingURL=deepler.min.js.map